//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed
#property indicator_color3 DeepSkyBlue
#property indicator_color4 PaleVioletRed
#property indicator_color5 DeepSkyBlue
#property indicator_color6 PaleVioletRed
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2

//
//
//
//
//

#define PRICE_HIGH_LOW 7

extern string TimeFrame    = "Ccurrent time frame";
extern int    MaPeriod     = 10;
extern int    MaShift      = 0;
extern int    MaMethod     = 0;
extern int    Price        = PRICE_HIGH_LOW;
extern double Deviation    = 0.0;
extern int    RsxLength    = 14;
extern int    RsxPrice     = PRICE_TYPICAL;
extern double RsxLevelUp   = 70;  
extern double RsxLevelDown = 30;  
extern bool   Interpolate  = true;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = true;

//
//
//
//
//

double UpLine[];
double DnLine[]; 
double UpArrow[];
double DnArrow[]; 
double UpBar[];
double DnBar[]; 
double trend[];
double trendRsx[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,UpLine);  SetIndexShift(0,MaShift);
      SetIndexBuffer(1,DnLine);  SetIndexShift(1,MaShift);
      SetIndexBuffer(2,UpBar);   SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,DnBar);   SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,UpArrow); SetIndexShift(4,MaShift); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,159);
      SetIndexBuffer(5,DnArrow); SetIndexShift(5,MaShift); SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,159);
      SetIndexBuffer(6,trend);
      SetIndexBuffer(7,trendRsx);
   
      //
      //
      // 
      //
      //
   
         MaPeriod          = MathMax(MaPeriod,2);
         Deviation         = MathMax(MathMin(Deviation,100),0.0);
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);

   IndicatorShortName(timeFrameToString(timeFrame)+" trend envelopes("+MaPeriod+")");
   return(0);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][16];
#define rsx  13
#define smin 14
#define smax 15

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,n,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { UpLine[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
      
      //
      //
      //
      //
      //
      
      double Kg = (3.0)/(2.0+RsxLength); 
      double Hg = 1.0-Kg;
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      { 
         if (Price==PRICE_HIGH_LOW)
            {
               work[r][smax] = (1.0+Deviation/100.0)*iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_HIGH,i);
               work[r][smin] = (1.0+Deviation/100.0)*iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_LOW ,i);
            }            
         else            
            {
               work[r][smax] = (1.0+Deviation/100.0)*iMA(NULL,0,MaPeriod,0,MaMethod,Price,i);
               work[r][smin] = (1.0-Deviation/100.0)*iMA(NULL,0,MaPeriod,0,MaMethod,Price,i);
            }
         UpLine[i]  = EMPTY_VALUE;
         DnLine[i]  = EMPTY_VALUE;
         UpArrow[i] = EMPTY_VALUE;
         DnArrow[i] = EMPTY_VALUE;
         UpBar[i]   = EMPTY_VALUE;
         DnBar[i]   = EMPTY_VALUE;
         trend[i]   = trend[i+1]; 
   
         //
         //
         //
         //
         //
         
	      if (Close[i]>work[r-1][smax]) trend[i]= 1; 
	      if (Close[i]<work[r-1][smin]) trend[i]=-1;
	      if (trend[i]>0 && work[r][smin]<work[r-1][smin]) work[r][smin]=work[r-1][smin];
	      if (trend[i]<0 && work[r][smax]>work[r-1][smax]) work[r][smax]=work[r-1][smax];
         if (trend[i] == 1)
            {  
               UpLine[i] = work[r][smin]; if (trend[i+1]!= 1) UpArrow[i] = UpLine[i];
            }
         if (trend[i] ==-1)
            {  
               DnLine[i] = work[r][smax]; if (trend[i+1]!=-1) DnArrow[i] = DnLine[i];
            }

      
         //
         //
         //
         //
         //

         work[r][12] = iMA(NULL,0,1,0,MODE_SMA,RsxPrice,i);

            if (i==(Bars-1)) { for (int c=0; c<12; c++) work[r][c] = 0; continue; }  

            //
            //
            //
            //
            //
      
            double mom = work[r][12]-work[r-1][12];
            double moa = MathAbs(mom);
            for (k=0; k<3; k++)
            {
               int kk = k*2;
                  work[r][kk+0] = Kg*mom           + Hg*work[r-1][kk+0];
                  work[r][kk+1] = Kg*work[r][kk+0] + Hg*work[r-1][kk+1]; mom = 1.5*work[r][kk+0] - 0.5 * work[r][kk+1];
                  work[r][kk+6] = Kg*moa           + Hg*work[r-1][kk+6];
                  work[r][kk+7] = Kg*work[r][kk+6] + Hg*work[r-1][kk+7]; moa = 1.5*work[r][kk+6] - 0.5 * work[r][kk+7];
            }
            if (moa != 0)
                 work[r][rsx] = MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00); 
            else work[r][rsx] = 50.0;
         
         //
         //
         //
         //
         
         trendRsx[i] = 0; 
            if (work[r][rsx]>RsxLevelUp  )                              trendRsx[i] =  1;
            if (work[r][rsx]<RsxLevelDown)                              trendRsx[i] = -1;
            if (trend[i]!=trend[i+1] && trendRsx[i]!=trend[i] && trendRsx[i]!=0)
               if (trendRsx[i]==-1)
                     { UpBar[i] = High[i]; DnBar[i] = Low[i]; }
               else  { UpBar[i] = Low[i]; DnBar[i] = High[i]; }
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         UpLine[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaShift,MaMethod,Price,Deviation,RsxLength,RsxPrice,RsxLevelUp,RsxLevelDown,0,y);
         DnLine[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaShift,MaMethod,Price,Deviation,RsxLength,RsxPrice,RsxLevelUp,RsxLevelDown,1,y);
         trend[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaShift,MaMethod,Price,Deviation,RsxLength,RsxPrice,RsxLevelUp,RsxLevelDown,6,y);
         trendRsx[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaShift,MaMethod,Price,Deviation,RsxLength,RsxPrice,RsxLevelUp,RsxLevelDown,7,y);
         UpArrow[i] = EMPTY_VALUE;
         DnArrow[i] = EMPTY_VALUE;
         UpBar[i]   = EMPTY_VALUE;
         DnBar[i]   = EMPTY_VALUE;
            if (UpLine[i]!= EMPTY_VALUE && UpLine[i+1]==EMPTY_VALUE) UpArrow[i]=UpLine[i];
            if (DnLine[i]!= EMPTY_VALUE && DnLine[i+1]==EMPTY_VALUE) DnArrow[i]=DnLine[i];
            if (trend[i]!=trend[i+1] && trendRsx[i]!=trend[i] && trendRsx[i]!=0)
               if (trendRsx[i]==-1)
                     { UpBar[i] = High[i]; DnBar[i] = Low[i]; }
               else  { UpBar[i] = Low[i]; DnBar[i] = High[i]; }
               
         //
         //
         //
         //
         //
                        
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(k = 1; k < n; k++)
            {
               if (UpLine[i]!=EMPTY_VALUE && UpLine[i+n]!=EMPTY_VALUE) UpLine[i+k] = UpLine[i] + (UpLine[i+n]-UpLine[i])*k/n;
               if (DnLine[i]!=EMPTY_VALUE && DnLine[i+n]!=EMPTY_VALUE) DnLine[i+k] = DnLine[i] + (DnLine[i+n]-DnLine[i])*k/n;
            }
   }
   manageAlerts();
   return(0);         
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue &&  alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (UpBar[whichBar] != EMPTY_VALUE)
         if (trend[whichBar] == 1)
               doAlert(whichBar," signal up");
         else  doAlert(whichBar," signal down");
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(timeFrameToString(timeFrame)," ",Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," trend envelopes & rsx ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"trend envelopes & rsx  "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}